org.scalatest.prop

# Checkers

#### trait Checkers extends Configuration

Trait that contains several “check” methods that perform ScalaCheck property checks. If ScalaCheck finds a test case for which a property doesn't hold, the problem will be reported as a ScalaTest test failure.

To use ScalaCheck, you specify properties and, in some cases, generators that generate test data. You need not always create generators, because ScalaCheck provides many default generators for you that can be used in many situations. ScalaCheck will use the generators to generate test data and with that data run tests that check that the property holds. Property-based tests can, therefore, give you a lot more testing for a lot less code than assertion-based tests. Here's an example of using ScalaCheck from a `JUnitSuite`:

    import org.scalatest.junit.JUnitSuite
    import org.scalatest.prop.Checkers
    import org.scalacheck.Arbitrary._
    import org.scalacheck.Prop._

    class MySuite extends JUnitSuite with Checkers {
      @Test
      def testConcat() {
        check((a: List[Int], b: List[Int]) => a.size + b.size == (a ::: b).size)
      }
    }

The `check` method, defined in `Checkers`, makes it easy to write property-based tests inside ScalaTest, JUnit, and TestNG test suites. This example specifies a property that `List`'s `:::` method should obey. ScalaCheck properties are expressed as function values that take the required test data as parameters. ScalaCheck will generate test data using generators and repeatedly pass generated data to the function. In this case, the test data is composed of integer lists named `a` and `b`. Inside the body of the function, you see:

    a.size + b.size == (a ::: b).size

The property in this case is a `Boolean` expression that will yield true if the size of the concatenated list is equal to the size of each individual list added together. With this small amount of code, ScalaCheck will generate possibly hundreds of value pairs for `a` and `b` and test each pair, looking for a pair of integers for which the property doesn't hold. If the property holds true for every value ScalaCheck tries, `check` returns normally. Otherwise, `check` will complete abruptly with a `TestFailedException` that contains information about the failure, including the values that cause the property to be false.

For more information on using ScalaCheck properties, see the documentation for ScalaCheck, which is available from http://code.google.com/p/scalacheck/.

To execute a suite that mixes in `Checkers` with ScalaTest's `Runner`, you must include ScalaCheck's jar file on the class path or runpath.

#### Property check configuration

The property checks performed by the `check` methods of this trait can be flexibly configured via the services provided by supertrait `Configuration`. The five configuration parameters for property checks along with their default values and meanings are described in the following table:

Configuration Parameter | Default Value | Meaning
--- | --- | ---
minSuccessful | 100 | the minimum number of successful property evaluations required for the property to pass
maxDiscarded | 500 | the maximum number of discarded property evaluations allowed during a property check
minSize | 0 | the minimum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists)
maxSize | 100 | the maximum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists)
workers | 1 | specifies the number of worker threads to use during property evaluation

The `check` methods of trait `Checkers` each take a `PropertyCheckConfig` object as an implicit parameter. This object provides values for each of the five configuration parameters. Trait `Configuration` provides an implicit `val` named `generatorDrivenConfig` with each configuration parameter set to its default value. If you want to set one or more configuration parameters to a different value for all property checks in a suite you can override this val (or hide it, for example, if you are importing the members of the `Checkers` companion object rather than mixing in the trait.) For example, if you want all parameters at their defaults except for `minSize` and `maxSize`, you can override `generatorDrivenConfig`, like this:

    implicit override val generatorDrivenConfig =
      PropertyCheckConfig(minSize = 10, maxSize = 20)

Or, if hide it by declaring a variable of the same name in whatever scope you want the changed values to be in effect:

    implicit val generatorDrivenConfig =
      PropertyCheckConfig(minSize = 10, maxSize = 20)

In addition to taking a `PropertyCheckConfig` object as an implicit parameter, the `check` methods of trait `Checkers` also take a variable length argument list of `PropertyCheckConfigParam` objects that you can use to override the values provided by the implicit `PropertyCheckConfig` for a single `check` invocation. You place these configuration settings after the property or property function, For example, if you want to set `minSuccessful` to 500 for just one particular `check` invocation, you can do so like this:

    check((n: Int) => n + 0 == n, minSuccessful(500))

This invocation of `check` will use 500 for `minSuccessful` and whatever values are specified by the implicitly passed `PropertyCheckConfig` object for the other configuration parameters. If you want to set multiple configuration parameters in this way, just list them separated by commas:

    check((n: Int) => n + 0 == n, minSuccessful(500), maxDiscarded(300))

The previous configuration approach works the same in `Checkers` as it does in `GeneratorDrivenPropertyChecks`. Trait `Checkers` also provides one `check` method that takes an `org.scalacheck.Test.Params` object, in case you want to configure ScalaCheck that way.

    import org.scalacheck.Prop
    import org.scalacheck.Test.Params
    import org.scalatest.prop.Checkers._

    check(Prop.forAll((n: Int) => n + 0 == n), Params(minSuccessfulTests = 5))

For more information, see the documentation for supertrait `Configuration`.

Linear Supertypes
Configuration, AnyRef, Any
Known Subclasses
Checkers
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Checkers
2. Configuration
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Type Members

1. #### case class MaxDiscarded (value: Int) extends PropertyCheckConfigParam with Product with Serializable

   A `PropertyCheckConfigParam` that specifies the maximum number of discarded property evaluations allowed during property evaluation.

2. #### case class MaxSize (value: Int) extends PropertyCheckConfigParam with Product with Serializable

   A `PropertyCheckConfigParam` that specifies the maximum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists).

3. #### case class MinSize (value: Int) extends PropertyCheckConfigParam with Product with Serializable

   A `PropertyCheckConfigParam` that specifies the minimum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists).

4. #### case class MinSuccessful (value: Int) extends PropertyCheckConfigParam with Product with Serializable

   A `PropertyCheckConfigParam` that specifies the minimum number of successful property evaluations required for the property to pass.

5. #### case class PropertyCheckConfig (minSuccessful: Int, maxDiscarded: Int, minSize: Int, maxSize: Int, workers: Int) extends Product with Serializable

   Configuration object for property checks.

6. #### class PropertyCheckConfigParam extends AnyRef

   Abstract class defining a family of configuration parameters for property checks.

7. #### case class Workers (value: Int) extends PropertyCheckConfigParam with Product with Serializable

   A `PropertyCheckConfigParam` that specifies the number of worker threads to use when evaluating a property.

### Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

7. #### def check (p: Prop, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig): Unit

   Check a property.

   Check a property.

   p

     the property to check

8. #### def check (p: Prop, prms: Params): Unit

   Check a property with the given testing parameters.

   Check a property with the given testing parameters.

   p

     the property to check

   prms

     the test parameters

9. #### def check [A1, A2, A3, A4, A5, A6, P] (f: (A1, A2, A3, A4, A5, A6) ⇒ P, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig, p: (P) ⇒ Prop, a1: Arbitrary[A1], s1: Shrink[A1], pp1: (A1) ⇒ Pretty, a2: Arbitrary[A2], s2: Shrink[A2], pp2: (A2) ⇒ Pretty, a3: Arbitrary[A3], s3: Shrink[A3], pp3: (A3) ⇒ Pretty, a4: Arbitrary[A4], s4: Shrink[A4], pp4: (A4) ⇒ Pretty, a5: Arbitrary[A5], s5: Shrink[A5], pp5: (A5) ⇒ Pretty, a6: Arbitrary[A6], s6: Shrink[A6], pp6: (A6) ⇒ Pretty): Unit

   Convert the passed 6-arg function into a property, and check it.

   Convert the passed 6-arg function into a property, and check it.

   f

     the function to be converted into a property and checked

10. #### def check [A1, A2, A3, A4, A5, P] (f: (A1, A2, A3, A4, A5) ⇒ P, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig, p: (P) ⇒ Prop, a1: Arbitrary[A1], s1: Shrink[A1], pp1: (A1) ⇒ Pretty, a2: Arbitrary[A2], s2: Shrink[A2], pp2: (A2) ⇒ Pretty, a3: Arbitrary[A3], s3: Shrink[A3], pp3: (A3) ⇒ Pretty, a4: Arbitrary[A4], s4: Shrink[A4], pp4: (A4) ⇒ Pretty, a5: Arbitrary[A5], s5: Shrink[A5], pp5: (A5) ⇒ Pretty): Unit

    Convert the passed 5-arg function into a property, and check it.

    Convert the passed 5-arg function into a property, and check it.

    f

      the function to be converted into a property and checked

11. #### def check [A1, A2, A3, A4, P] (f: (A1, A2, A3, A4) ⇒ P, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig, p: (P) ⇒ Prop, a1: Arbitrary[A1], s1: Shrink[A1], pp1: (A1) ⇒ Pretty, a2: Arbitrary[A2], s2: Shrink[A2], pp2: (A2) ⇒ Pretty, a3: Arbitrary[A3], s3: Shrink[A3], pp3: (A3) ⇒ Pretty, a4: Arbitrary[A4], s4: Shrink[A4], pp4: (A4) ⇒ Pretty): Unit

    Convert the passed 4-arg function into a property, and check it.

    Convert the passed 4-arg function into a property, and check it.

    f

      the function to be converted into a property and checked

12. #### def check [A1, A2, A3, P] (f: (A1, A2, A3) ⇒ P, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig, p: (P) ⇒ Prop, a1: Arbitrary[A1], s1: Shrink[A1], pp1: (A1) ⇒ Pretty, a2: Arbitrary[A2], s2: Shrink[A2], pp2: (A2) ⇒ Pretty, a3: Arbitrary[A3], s3: Shrink[A3], pp3: (A3) ⇒ Pretty): Unit

    Convert the passed 3-arg function into a property, and check it.

    Convert the passed 3-arg function into a property, and check it.

    f

      the function to be converted into a property and checked

13. #### def check [A1, A2, P] (f: (A1, A2) ⇒ P, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig, p: (P) ⇒ Prop, a1: Arbitrary[A1], s1: Shrink[A1], pp1: (A1) ⇒ Pretty, a2: Arbitrary[A2], s2: Shrink[A2], pp2: (A2) ⇒ Pretty): Unit

    Convert the passed 2-arg function into a property, and check it.

    Convert the passed 2-arg function into a property, and check it.

    f

      the function to be converted into a property and checked

14. #### def check [A1, P] (f: (A1) ⇒ P, configParams: PropertyCheckConfigParam*)(implicit config: PropertyCheckConfig, p: (P) ⇒ Prop, a1: Arbitrary[A1], s1: Shrink[A1], pp1: (A1) ⇒ Pretty): Unit

    Convert the passed 1-arg function into a property, and check it.

    Convert the passed 1-arg function into a property, and check it.

    f

      the function to be converted into a property and checked

15. #### def clone (): AnyRef

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

16. #### def eq (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

17. #### def equals (arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

18. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

19. #### implicit val generatorDrivenConfig : PropertyCheckConfig

    Implicit `PropertyCheckConfig` value providing default configuration values.

    Implicit `PropertyCheckConfig` value providing default configuration values.

    Attributes
      implicit
    Definition Classes
      Configuration

20. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

21. #### def hashCode (): Int

    Definition Classes
      AnyRef → Any

22. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

23. #### def maxDiscarded (value: Int): MaxDiscarded

    Returns a `MaxDiscarded` property check configuration parameter containing the passed value, which specifies the maximum number of discarded property evaluations allowed during property evaluation.

    Returns a `MaxDiscarded` property check configuration parameter containing the passed value, which specifies the maximum number of discarded property evaluations allowed during property evaluation.

    Definition Classes
      Configuration

24. #### def maxSize (value: Int): MaxSize

    Returns a `MaxSize` property check configuration parameter containing the passed value, which specifies the maximum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists).

    Returns a `MaxSize` property check configuration parameter containing the passed value, which specifies the maximum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists).

    Note that the maximum size should be greater than or equal to the minimum size. This requirement is enforced by the `PropertyCheckConfig` constructor and the `forAll` methods of traits `PropertyChecks` and `Checkers`. In other words, it is enforced at the point both a maximum and minimum size are provided together.

    Definition Classes
      Configuration

25. #### def minSize (value: Int): MinSize

    Returns a `MinSize` property check configuration parameter containing the passed value, which specifies the minimum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists).

    Returns a `MinSize` property check configuration parameter containing the passed value, which specifies the minimum size parameter to provide to ScalaCheck, which it will use when generating objects for which size matters (such as strings or lists).

    Definition Classes
      Configuration

26. #### def minSuccessful (value: Int): MinSuccessful

    Returns a `MinSuccessful` property check configuration parameter containing the passed value, which specifies the minimum number of successful property evaluations required for the property to pass.

    Returns a `MinSuccessful` property check configuration parameter containing the passed value, which specifies the minimum number of successful property evaluations required for the property to pass.

    Definition Classes
      Configuration

27. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

28. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

29. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

30. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

31. #### def toString (): String

    Definition Classes
      AnyRef → Any

32. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

33. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

34. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

35. #### def workers (value: Int): Workers

    Returns a `Workers` property check configuration parameter containing the passed value, which specifies the number of worker threads to use when evaluating a property.

    Returns a `Workers` property check configuration parameter containing the passed value, which specifies the number of worker threads to use when evaluating a property.

    Definition Classes
      Configuration

### Inherited from Configuration

### Inherited from AnyRef

### Inherited from Any